namespace LibSernatur {
	namespace DB {
		using Postgres;
		using Wrapper;

		public class Especialidad : GLib.Object {
			public uint id_especialidad { get; set; default = 0; }
			public string descripcion_especialidad { get; set; default = ""; }

			public Especialidad (uint id_especialidad = 0, string descripcion_especialidad = "") {
				this.id_especialidad = id_especialidad;
				this.descripcion_especialidad = descripcion_especialidad;
			}

			public static Especialidad[]? get_all_especialidades(Database conn) {
				var res = conn.exec ("
SELECT id_especialidad, descripcion_especialidad FROM especialidad
				");
				if (res.get_status () != ExecStatus.TUPLES_OK) {
					#if DEBUG
						error (conn.get_error_message ());
					#else
						warning (conn.get_error_message ());
						return null;
					#endif
				}

				var wra = new ResultWrapper (res);
				Especialidad[] especialidades = {};
				int n = res.get_n_tuples ();
				for (int i = 0; i < n; i++) {
					try {
						var especialidad = new Especialidad (wra.get_int_n (i, "id_especialidad"),
							wra.get_string_n (i, "descripcion_especialidad")
						);
						especialidades += especialidad;
					}
					catch (Error e) {
						#if DEBUG
							error (e.message);
						#else
							warning (e.message);
						#endif
					}
				}
				return especialidades;
			}
		}
	}
}
